%define name bacula
%define version 1.32f
%define release 2mdk

%define MYSQL 0
%define GNOME 1
%define TCPW 1

%{?_with_mysql: %{expand: %%global MYSQL 1}}
%{?_without_mysql: %{expand: %%global MYSQL 0}}
%{?_with_gnome: %{expand: %%global GNOME 1}}
%{?_without_gnome: %{expand: %%global GNOME 0}}
%{?_with_wrap: %{expand: %%global TCPW 1}}
%{?_without_wrap: %{expand: %%global TCPW 0}}

%define blurb Bacula - It comes by night and sucks the vital essence from your computers.

# fixes passwords in configuration files
# removing "SubSys Directory" is needed if upgrading from 1.30a or lower
%define post_fix_config() umask 0037; if [ -s %{_sysconfdir}/%{name}/.pw.sed ]; then for i in %{_sysconfdir}/%{name}/%{1}.conf %{_sysconfdir}/%{name}/%{1}.conf.rpmnew; do if [ -s $i ]; then sed -f %{_sysconfdir}/%{name}/.pw.sed $i > $i.tmp; sed -e '/SubSys[[:space:]]*Directory/I d' $i.tmp > $i; rm -f $i.tmp; fi; done; fi;

Summary: Bacula - The Network Backup Solution
Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		1
Group:		Archiving/Backup
License:	GPL
Source:		http://www.prdownloads.sourceforge.net/bacula/%{name}-%{version}.tar.bz2
Source1:	%{name}-icons.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-root
URL:		http://www.bacula.org/
BuildRequires: readline-devel, perl-base, zlib-devel
%if %{TCPW}
BuildRequires: tcp_wrappers-devel
%endif
Patch0:		bacula-1.32f-config.diff.bz2
Patch1:		bacula-1.30a-prompt.diff.bz2
Patch2:		bacula-1.32f-pidfile.diff.bz2
Patch11:	1.32f-1-weekofmonth.patch.bz2
Patch12:	1.32f-2-eom-nextvol.patch.bz2
Patch13:	1.32f-3-win32-permissions.patch.bz2
Patch14:	1.32f-4-run-crash.patch.bz2

%description
%{blurb}
Bacula is a set of computer programs that permit you (or the system
administrator) to manage backup, recovery, and verification of computer
data across a network of computers of different kinds. In technical terms,
it is a network client/server based backup program. Bacula is relatively
easy to use and efficient, while offering many advanced storage management
features that make it easy to find and recover lost or damaged files.

%package common
Summary:	Common files for bacula package
Group:		Archiving/Backup
Prereq:		rpm-helper
Conflicts:	bacula-dir < %epoch:%version-%release
Conflicts:	bacula-fd < %epoch:%version-%release
Conflicts:	bacula-sd < %epoch:%version-%release
Conflicts:	bacula-console < %epoch:%version-%release
Conflicts:	bacula-console-gnome < %epoch:%version-%release

%description common
%{blurb}
Bacula is a set of computer programs that permit you (or the system
administrator) to manage backup, recovery, and verification of computer
data across a network of computers of different kinds. In technical terms,
it is a network client/server based backup program. Bacula is relatively
easy to use and efficient, while offering many advanced storage management
features that make it easy to find and recover lost or damaged files.

%package dir
Summary:	Bacula Director and Catalog services
Group:		Archiving/Backup
Prereq:		rpm-helper, perl-base, sed
Prereq:		bacula-common = %epoch:%version-%release
%if %{MYSQL}
Requires:	MySQL >= 3.23
BuildRequires: MySQL-devel >= 3.23
%else
Requires:	sqlite-tools
BuildRequires: sqlite-devel
%endif

%description dir
%{blurb}
Bacula Director is the program that supervises all the backup, restore, verify
and archive operations. The system administrator uses the Bacula Director to
schedule backups and to recover files.
Catalog services are comprised of the software programs responsible for
maintaining the file indexes and volume databases for all files backed up.
The Catalog services permit the System Administrator or user to quickly locate
and restore any desired file, since it maintains a record of all Volumes used,
all Jobs run, and all Files saved.
%if %{MYSQL}
This build requires MySQL to be installed separately as the catalog database.
%else
This build requires sqlite to be installed separately as the catalog database.
%endif

%package console
Summary:	Bacula Console
Group:		Archiving/Backup
Prereq:		sed
Prereq:		bacula-common = %epoch:%version-%release

%description console
%{blurb}
Bacula Console is the program that allows the administrator or user to
communicate with the Bacula Director.
This is the text only console interface.

%if %{GNOME}
%package console-gnome
Summary:	Bacula Gnome Console
Group:		Archiving/Backup
BuildRequires: libgnomeui2-devel
Prereq:		sed
Prereq:		bacula-common = %epoch:%version-%release

%description console-gnome
%{blurb}
Bacula Console is the program that allows the administrator or user to
communicate with the Bacula Director.
This is the GNOME GUI interface.
%endif

%package fd
Summary:	Bacula File services (Client)
Group:		Archiving/Backup
Prereq:		rpm-helper, sed
Prereq:		bacula-common = %epoch:%version-%release

%description fd
%{blurb}
Bacula File services (or Client program) is the software program that is
installed on the machine to be backed up. It is specific to the operating
system on which it runs and is responsible for providing the file attributes
and data when requested by the Director. The File services are also responsible
for the file system dependent part of restoring the file attributes and data
during a recovery operation.
This program runs as a daemon on the machine to be backed up, and in some of
the documentation, the File daemon is referred to as the Client (for example in
Bacula configuration file). 

%package sd
Summary:	Bacula Storage services
Group:		Archiving/Backup
Prereq:		rpm-helper, sed
Prereq:		bacula-common = %epoch:%version-%release

%description sd
%{blurb}
Bacula Storage services consist of the software programs that perform the
storage and recovery of the file attributes and data to the physical backup
media or volumes. In other words, the Storage daemon is responsible for reading
and writing your tapes (or other storage media, e.g. files).
The Storage services runs as a daemon on the machine that has the backup
device (usually a tape drive).

%prep
%setup -q
%patch11 -p0 -b .weekofmonth
%patch12 -p0 -b .eom-nextvol
%patch13 -p0 -b .win32-permissions
%patch14 -p1 -b .run-crash

%patch0 -p1 -b .config
%patch1 -p1 -b .prompt
%patch2 -p1 -b .pidfile
mkdir doc/manual
mv doc/html-manual/*.html doc/manual
mv doc/html-manual/*.css doc/manual
mv doc/html-manual/*.gif doc/manual

%build
%serverbuild
%configure \
	--enable-smartalloc \
%if %{MYSQL}
        --with-mysql \
%else
        --with-sqlite \
%endif
%if %{GNOME}
		--enable-gnome \
%endif
%if %{TCPW}
		--with-tcp-wrappers \
%endif
        --sysconfdir=%{_sysconfdir}/%{name} \
        --with-scriptdir=%{_libexecdir}/%{name} \
        --with-working-dir=%{_localstatedir}/%{name} \
        --with-subsys-dir=/var/lock/subsys \
		--with-dir-password="#FAKE#DIR#PASSWORD#" \
		--with-fd-password="#FAKE#FD#PASSWORD#" \
		--with-sd-password="#FAKE#SD#PASSWORD#"

%make

%install
rm -rf %{buildroot}
%makeinstall sysconfdir=%{buildroot}%{_sysconfdir}/%{name} scriptdir=%{buildroot}%{_libexecdir}/%{name} working_dir=%{buildroot}%{_localstatedir}/%{name}

# install the upgrade scripts
%if %{MYSQL}
install -m 755 src/cats/alter_mysql_tables %{buildroot}%{_libexecdir}/%{name}
%else
install -m 755 src/cats/alter_sqlite_tables %{buildroot}%{_libexecdir}/%{name}
%endif

# install the init scripts
mkdir -p %{buildroot}%{_initrddir}
install -m 755 platforms/mandrake/bacula-dir %{buildroot}%{_initrddir}/bacula-dir
install -m 755 platforms/mandrake/bacula-fd %{buildroot}%{_initrddir}/bacula-fd
install -m 755 platforms/mandrake/bacula-sd %{buildroot}%{_initrddir}/bacula-sd

# install the logrotate file
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
cp scripts/logrotate %{buildroot}%{_sysconfdir}/logrotate.d/bacula-dir

mkdir -p %{buildroot}%{_localstatedir}/%{name}

%if %{GNOME}
# install the menu stuff
mkdir -p $RPM_BUILD_ROOT%{_menudir}
cat << EOF > $RPM_BUILD_ROOT%{_menudir}/%{name}-console-gnome
?package(%{name}-console-gnome): command="%{_sbindir}/gnome-console" icon="%{name}.png" needs="x11" title="Bacula Console" longtitle="Bacula Director Console" section="System/Archiving/Backup"
EOF
mkdir -p %{buildroot}%{_iconsdir}
tar jxvf %{SOURCE1} -C %{buildroot}%{_iconsdir}
%endif

perl -spi -e 's/"#FAKE#(\w+)#PASSWORD#"/#YOU MUST SET THE $1 PASSWORD#/' %{buildroot}%{_sysconfdir}/%{name}/*.conf
touch %{buildroot}%{_sysconfdir}/%{name}/.pw.sed

%clean
rm -rf %{buildroot}

%files common
%defattr(644, root, root, 755)
%dir %{_sysconfdir}/%{name}
%attr(755, root, root) %{_sbindir}/btraceback
%attr(755, root, root) %{_sbindir}/smtp
%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/btraceback.gdb
%attr(700, bacula, bacula) %dir %{_localstatedir}/%{name}

%pre common
%_pre_useradd bacula %{_localstatedir}/%{name} /bin/false
#__pre_groupadd TAPE_GROUP bacula

%postun common
%_postun_userdel bacula

%files dir
%defattr(644, root, root, 755)
%doc ChangeLog CheckList ReleaseNotes kernstodo
%doc doc/*.pdf doc/manual examples
%attr(600, root, root) %config(noreplace) %{_sysconfdir}/%{name}/bacula-dir.conf
%ghost %{_sysconfdir}/%{name}/.pw.sed
%config(noreplace) %{_sysconfdir}/logrotate.d/bacula-dir
%defattr (755, root, root)
%config(noreplace) %{_initrddir}/bacula-dir
%{_sbindir}/bacula-dir
%{_sbindir}/dbcheck
%if %{MYSQL}
%{_libexecdir}/%{name}/create_mysql_database
%{_libexecdir}/%{name}/drop_mysql_tables
%{_libexecdir}/%{name}/grant_mysql_privileges
%{_libexecdir}/%{name}/make_mysql_tables
%{_libexecdir}/%{name}/alter_mysql_tables
%else
%{_libexecdir}/%{name}/create_sqlite_database
%{_libexecdir}/%{name}/drop_sqlite_tables
%exclude %{_libexecdir}/%{name}/grant_mysql_privileges
%{_libexecdir}/%{name}/make_sqlite_tables
%{_libexecdir}/%{name}/alter_sqlite_tables
%endif
%{_libexecdir}/%{name}/delete_catalog_backup
%{_libexecdir}/%{name}/drop_bacula_tables
%{_libexecdir}/%{name}/make_bacula_tables
%{_libexecdir}/%{name}/make_catalog_backup
%attr(644, root, root) %{_libexecdir}/%{name}/query.sql

%pre dir
/usr/bin/perl -e '
exit 0 if ( -f "%{_sysconfdir}/%{name}/.pw.sed");
mkdir("%{_sysconfdir}/%{name}");
umask(0077);
open(IN, "/dev/random") or die "$!";
open(OUT, ">%{_sysconfdir}/%{name}/.pw.sed") or die "$!";
foreach $c ("DIR","SD","FD") {
read(IN, $buf, 32);
my $res = pack("u", $buf);
$res =~ s/^.//mg;
$res =~ s/\n//g;
$res =~ tr|` -_|AA-Za-z0-9+/|;
	print OUT "s!#YOU MUST SET THE $c PASSWORD#!\"$res\"!\n";
}
close (IN);
close (OUT);
'

%post dir
umask 077
%if %{MYSQL}
# NOTE: IF THIS FAILS DUE TO MYSQL NEEDING A PASSWORD YOU ARE ON YOUR OWN
DB_VER=`mysql bacula -e 'select * from Version;'|tail -n 1 2>/dev/null`
if [ -z "$DB_VER" ]; then
# grant privileges and create tables
	echo "Granting privileges for MySQL user bacula..."
	%{_libexecdir}/%{name}/grant_mysql_privileges > dev/null
	echo "Creating MySQL bacula database..."
	%{_libexecdir}/%{name}/create_mysql_database > dev/null
	echo "Creating bacula tables..."
	%{_libexecdir}/%{name}/make_mysql_tables > dev/null
elif [ "$DB_VER" -lt "6" ]; then
	echo "Backing up bacula tables"
	mysqldump -f --opt bacula | bzip2 > %{_localstatedir}/%{name}/bacula_backup.sql.bz2
	echo "Upgrading bacula tables"
	%{_libexecdir}/%{name}/alter_mysql_tables
	echo "If bacula works correctly you can remove the backup file %{_localstatedir}/%{name}/bacula_backup.sql.bz2"
fi
%else
if [ -s %{_localstatedir}/%{name}/bacula.db ]; then
DB_VER=`echo "select * from Version;" | sqlite %{_localstatedir}/%{name}/bacula.db|tail -n 1 2>/dev/null`
	if [ "$DB_VER" -lt "6" ]; then
		echo "Backing up bacula tables"
		echo ".dump" | sqlite %{_localstatedir}/%{name}/bacula.db | bzip2 > %{_localstatedir}/%{name}/bacula_backup.sql.bz2
		echo "Upgrading bacula tables"
		%{_libexecdir}/%{name}/alter_sqlite_tables
		echo "If bacula works correctly you can remove the backup file %{_localstatedir}/%{name}/bacula_backup.sql.bz2"
	fi
else
# create the tables
	echo "Creating bacula tables..."
	%{_libexecdir}/%{name}/make_sqlite_tables > dev/null
fi
%endif
chown -R bacula:bacula %{_localstatedir}/%{name}
chmod -R 600 %{_localstatedir}/%{name}
%post_fix_config *
%_post_service bacula-dir

%preun dir
%_preun_service bacula-dir

%files fd
%attr(600, root, root) %config(noreplace) %{_sysconfdir}/%{name}/bacula-fd.conf
%attr(755, root, root) %config(noreplace) %{_initrddir}/bacula-fd
%attr(755, root, root) %{_sbindir}/bacula-fd

%post fd
%post_fix_config bacula-fd
%_post_service bacula-fd

%preun fd
%_preun_service bacula-fd

%files sd
%defattr(755, root, root)
%dir %{_sysconfdir}/%{name}
%attr(600, root, root) %config(noreplace) %{_sysconfdir}/%{name}/bacula-sd.conf
%config(noreplace) %{_initrddir}/bacula-sd
%{_sbindir}/bacula-sd
%{_sbindir}/bcopy
%{_sbindir}/bextract
%{_sbindir}/bls
%{_sbindir}/bscan
%{_sbindir}/btape
%{_libexecdir}/%{name}/mtx-changer

%post sd
%post_fix_config bacula-sd
%_post_service bacula-sd

%preun sd
%_preun_service bacula-sd

%files console
%attr(600, root, root) %config(noreplace) %{_sysconfdir}/%{name}/console.conf
%attr(755, root, root) %{_sbindir}/console

%post console
%post_fix_config console

%if %{GNOME}
%files console-gnome
%defattr(644, root, root, 755)
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_menudir}/bacula-console-gnome
%attr(600, root, root) %config(noreplace) %{_sysconfdir}/%{name}/gnome-console.conf
%attr(755, root, root) %{_sbindir}/gnome-console

%post console-gnome
%post_fix_config gnome-console
%update_menus
		
%postun console-gnome
%clean_menus

%endif

%changelog
* Thu Feb 26 2004 Luca Berra <bluca@vodka.it> 1.32f-2mdk 
- added patches 1 to 4 from upstream
- split bacula-common package to ease upgrades
- some cleanups
- use epochs in requires

* Thu Jan 01 2004 Luca Berra <bluca@vodka.it> 1.32f-1mdk
- 1.32f
- revert .rpmnew change (it was not working anyway)
- DIRM: include directory %%{_sysconfig}/%%{name}
- use a macro to change passwords in config files in %%post
- removed subdir creation in %%setup
- added prereq sed to dir package
- changed default user for dir and sd daemons
- changed name of pid files, so killproc finds them
- more conflicts

* Tue Nov 04 2003 Luca Berra <bluca@vodka.it> 1.32d-1mdk
- 1.32d
- use gnome2 for console
- use tcp_wrappers
- try not to create unneeded .rpmnew in configuration

* Fri Aug 12 2003 Luca Berra <bluca@vodka.it> 1.31a-1mdk
- 1.31a
- modified %%post script to upgrade database if needed and do not try to create if it already exists.
- %%post_service should be last in %%post script
- changed sql upgrade script to remove multiple Version rows introduced by %%post
- trying to create the tables multiple times in previous releases.
- smtp is required by btraceback which is required by every daemon.
- added conflicts for lower version

* Wed Aug  6 2003 Luca Berra <bluca@vodka.it> 1.30a-3mdk
- changed sqlite requires to match package in contrib
- set passwords for single components to produce an error until user changes them
- try to change passwords automatically if dir package is installed

* Sun Aug  3 2003 Luca Berra <bluca@vodka.it> 1.30a-2mdk
- many spec changes
- almost please rpmlint
- fixed readline eats last message bug in console

* Fri Aug  1 2003 Luca Berra <bluca@vodka.it> 1.30a-1mdk
- Initial spec file from spec by D. Scott Barninger <barninger at fairfieldcomputers.com>
